/*======================================================================*\
|*		Editor mined						*|
|*		Interface						*|
|*		Character properties					*|
\*======================================================================*/

/* Han character descriptions table */

struct hanentry {
	unsigned long unicode;
	char * Mandarin;
	char * Cantonese;
	char * Japanese;
	char * Sino_Japanese;
	char * Hangul;
	char * Korean;
	char * Vietnamese;
	char * HanyuPinlu;
	char * HanyuPinyin;
	char * XHCHanyuPinyin;
	char * Tang;
	char * Definition;
};

extern struct hanentry * lookup_handescr _((unsigned long unichar));


/* Character name information */

extern char * charname _((unsigned long ucs));


/* Script information */

struct scriptentry {
	unsigned long first, last;
	int scriptname;
	int categoryname;
};

extern struct scriptentry * scriptinfo _((unsigned long ucs));

extern char * category_names [];


/* Case conversion conditions */

#define U_cond_Final_Sigma		0x01
#define U_cond_After_I			0x02
#define U_cond_After_Soft_Dotted	0x04
#define U_cond_More_Above		0x08
#define U_cond_Not_Before_Dot		0x10
#define U_cond_tr			0x20
#define U_cond_lt			0x40
#define U_cond_az			0x80
#define U_conds_lang	(U_cond_tr | U_cond_lt | U_cond_az)

/* Case conversion table */

struct caseconv_entry {
	unsigned long base;
	int toupper, tolower;
	unsigned long title;
};

extern struct caseconv_entry caseconv_table [];

typedef struct {unsigned short u1, u2, u3;} uniseq;

struct caseconv_special_entry {
	unsigned long base;
	uniseq lower, title, upper;
	short condition;
};

extern struct caseconv_special_entry caseconv_special [];

extern int lookup_caseconv _((unsigned long basechar));
extern int lookup_caseconv_special _((unsigned long basechar, short langcond));
extern unsigned long case_convert _((unsigned long unichar, int dir));


/* Various character properties */

extern int soft_dotted _((unsigned long ucs));
extern int iscombining_notabove _((unsigned long unichar));
extern int iscombining_above _((unsigned long unichar));
extern char * script _((unsigned long ucs));
extern unsigned long decomposition_base _((unsigned long ucs));
extern char * category _((unsigned long ucs));
extern FLAG isLetter _((unsigned long ucs));
extern FLAG is_wideunichar _((unsigned long ucs));
extern FLAG iscombining_unichar _((unsigned long ucs));
extern FLAG isspacingcombining_unichar _((unsigned long ucs));


/* Character decomposition information */

extern char * decomposition_string _((unsigned long ucs));


/*======================================================================*\
|*				End					*|
\*======================================================================*/
